# Hafnian C library

Previous version of the Hafnian library were written using C99, and requiring the LAPACKe C bindings to the LAPACK linear algebra library.

As of Hafnian version 0.3.0, the C Hafnian library has been deprecated, and this code ported to C++ (in addition to numerous other Hafnian algorithms and features). This allows us to benefit from:

* Generics, simplifying the amount of code to be maintained.

* Compatibility with the Microsoft Visual C++ 2015 compiler (MSVCC). Unfortunately, MSVCC does not fully support C99, in particular complex number support, leading to the inability to provide Windows compatible Python binaries for Hafnian v0.1.0.

* The C++ header-only Eigen library for linear algebra. This allows compilation on systems without BLAS/LAPACK installed, easing compilation. Furthermore, Eigen can be compiled to use BLAS/LAPACK as a backend if available, allowing use of the highly optimized BLAS/LAPACK routines with minimal additional effort.

To access the new features available in the C++ based Hafnian v0.3.0 and above, please see the main Hafnian documentation.

We leave the C library here for posterity, but it will likely not be updated.

## Installation

To compile the C extension library, you will need the following libraries:

* BLAS
* LAPACKe
* OpenMP

as well as a C99 compliant compiler (i.e. gcc).

On Debian-based systems, the above dependencies can be installed in one go via

```bash
$ sudo apt install liblapacke-dev
```

To compile the library on Linux, a makefile is provided. Simply run

```bash
$ make library
```

and the two libraries `lhafnian.so` (for complex matrices) and `rlhafnian.so` (for real matrices) will be created. Both libraries contain the functions `hafnian_loops(mat, n)` (for the loop hafnian) and `hafnian(mat, n)` (for the standard hafnian), where `mat` is a **flattened** n-by-n array of type `double` or `double complex` depending on the library used.

## Using the C interface

Simply include the required library at the top of your source code:

```c
#include "lhafnian.h"
```

and then you can call the provided hafnian functions directly:

```c
double complex hafval = hafnian_loops(mat, n);
```

To compile, simply provide the path to the corresponding `*lhafnian.so` library, as well as the linking flag. See the file `timing.c` for an example program, and the corresponding Makefile to see how it is compiled.

! Copyright 2019 Xanadu Quantum Technologies Inc.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

! Module containing custom precision types
module kinds
    implicit none

    integer, parameter :: sp = selected_real_kind(5,30)
    integer, parameter :: dp = selected_real_kind(9,99)
    integer, parameter :: qp = selected_real_kind(20,199)
    integer, parameter :: wp = dp
    integer, parameter :: ip = selected_int_kind(16)

    ! These empty arrays are used to initialize variables to either the min or
    ! max possible number of kind wp or integer.
    real(wp)    :: empty(2:1)
    integer(ip) :: iempty(2:1)
end module kinds

! Module containing some common variables
module vars
    use kinds
    implicit none

    integer(ip)         :: n, ell
    real(wp), parameter :: eps = 1.0d-6
    real(wp), parameter :: pi = acos(-1.0_wp)
end module vars

! Module containing some useful structures
module structures
    use kinds
    implicit none

    type GaussianState
        real(wp), allocatable :: rbar(:)   ! Mean vector of the state
        real(wp), allocatable :: V(:,:)    ! Covariance matrix of the state
        real(wp)              :: C         ! Probability Coefficients
    end type GaussianState

    real(wp) :: time, dtime
end module structures

module torontonian_samples
    use kinds
    use vars
    use structures

    implicit none

    contains

    subroutine GenerateSample(covmat, mean, n_sample, seed, sample_out)
        real(wp), intent(in)     :: covmat(:,:)
        real(wp), intent(in)     :: mean(:)
        integer(ip)              :: n_sample
        integer(ip), intent(in)  :: seed
        integer(ip), intent(out) :: sample_out(1:n_sample)

        ! local variables
        integer                  :: seed_tmp
        integer(ip), allocatable :: sample(:)

        integer(ip)                      :: i, j, k, ntmp, jj, NewStateSize
        real(wp)                         :: qq, qq1, qq2, random, TotalProb
        type(GaussianState)              :: state(1)
        type(GaussianState), allocatable :: state_tmp1(:), state_tmp2(:)

        !f2py intent(in) :: covmat
        !f2py intent(in) :: mean, seed, n_sample
        !f2py intent(out) :: sample_out

        seed_tmp = seed
        n = size(mean)
        ell = n/2

        call random_seed(seed_tmp)

        allocate(sample(1:ell))

        do i=1,size(state)
            allocate(state(i)%rbar(1:n),state(i)%V(1:n,1:n))
        end do

        state(1)%rbar = mean
        state(1)%V = covmat

        allocate(state_tmp1(1:size(state)))

        state_tmp1 = state

        call compute_q(state_tmp1(1)%V, state_tmp1(1)%rbar, qq)

        TotalProb = qq

        state_tmp1(:)%C = 1.0_wp

        do i=1,ell

            ntmp = size(state_tmp1)

            call random_number(random)

            NewStateSize = size(state_tmp1(1)%rbar) - 2

            if (NewStateSize >= 2) then
                if (qq > random) then

                    sample(i) = 0

                    do k=1,size(state_tmp1)
                        call compute_q(state_tmp1(k)%v, state_tmp1(k)%rbar, qq1)
                        state_tmp1(k)%c = state_tmp1(k)%c * qq1/qq
                    end do

                    allocate(state_tmp2(1:ntmp))

                    do jj=1,ntmp
                        allocate(state_tmp2(jj)%rbar(1:NewStateSize), &
                                 state_tmp2(jj)%V(1:NewStateSize, 1:NewStateSize))
                    end do

                    do j=1,ntmp
                        state_tmp2(j)%V = NewCovMat(state_tmp1(j)%V)
                        state_tmp2(j)%rbar = NewMean(state_tmp1(j)%rbar, state_tmp1(j)%V)
                        state_tmp2(j)%C = state_tmp1(j)%C
                    end do

                    deallocate(state_tmp1)
                    allocate(state_tmp1(1:size(state_tmp2)))
                    state_tmp1 = state_tmp2
                    deallocate(state_tmp2)

                    qq2 = 0.0_wp
                    qq1 = 0.0_wp

                    do k=1,size(state_tmp1)
                        call compute_q(state_tmp1(k)%v, state_tmp1(k)%rbar, qq1)
                        qq2 = qq2 + qq1*state_tmp1(k)%c
                    end do

                else if (qq <= random) then

                    sample(i) = 1
                        allocate(state_tmp2(1:2*ntmp))
                        do jj=1,2*ntmp
                            allocate(state_tmp2(jj)%rbar(1:NewStateSize), &
                                     state_tmp2(jj)%V(1:NewStateSize, 1:NewStateSize))
                        end do

                        do j=1,ntmp
                            state_tmp2(2*j-1)%V = NewCovMat(state_tmp1(j)%V)
                            state_tmp2(2*j-1)%rbar = NewMean(state_tmp1(j)%rbar, state_tmp1(j)%V)
                            call compute_q(state_tmp1(j)%V, state_tmp1(j)%rbar, qq1)
                            state_tmp2(2*j-1)%C = - state_tmp1(j)%C * qq1/(1.0_wp-qq)

                            state_tmp2(2*j)%V = VA(state_tmp1(j)%V)
                            state_tmp2(2*j)%rbar = rA(state_tmp1(j)%rbar, state_tmp1(j)%V)
                            state_tmp2(2*j)%C = state_tmp1(j)%C /(1.0_wp-qq)
                        end do

                    deallocate(state_tmp1)
                    allocate(state_tmp1(1:size(state_tmp2)))

                    state_tmp1 = state_tmp2

                    deallocate(state_tmp2)

                    qq2 = 0.0_wp
                    qq1 = 0.0_wp

                    if (abs(sum(state_tmp1(:)%C) - 1.0_wp) > 1e-6) then
                        write(*, *)"Error: Sum of all coefficients not 1. Sum =", sum(state_tmp1(:)%C)
                        STOP
                    end if

                    do k=1,size(state_tmp1)
                        call compute_q(state_tmp1(k)%V, state_tmp1(k)%rbar, qq1)
                        qq2 = qq2 + qq1*state_tmp1(k)%C
                    end do

                end if

            else
                if (qq > random) then
                     sample(i) = 0
                else if (qq <= random) then
                     sample(i) = 1
                end if
            end if

            qq = qq2

            if (qq < -eps) then
                print*, "Error: Probability is less than 0. q = ", qq
            else if (qq - 1.0_wp > 0.01_wp) then
                print*, "Error: Probability is less greater than 1. q = ", qq
            end if

            if (qq < 0.0_wp) then
                print*, 'Warning: probability was a small negative number, q=', qq, "Set to Zero!"
                qq = 0.0_wp
            end if

            TotalProb = TotalProb * qq

        end do

        forall(i=1:ell) sample_out(i) = sample(ell+1-i)
    end subroutine GenerateSample

    pure function VA(mat)
        real(wp), intent(in) :: mat(:, :)
        real(wp), allocatable :: VA(:, :)

        ! local variables
        integer(ip) :: i, nn

        nn = sqrt(real(size(mat),wp))

        allocate(VA(1:nn-2,1:nn-2))

        VA = mat(1:nn-2,1:nn-2)
    end function VA

    pure function rA(rbar, mat)
        real(wp), intent(in)  :: rbar(:)
        real(wp), intent(in)  :: mat(:, :)
        real(wp), allocatable :: rA(:)

        ! local variables
        integer(ip) :: i, nn

        nn = sqrt(real(size(mat),wp))

        allocate(rA(1:nn-2) )

        rA = rbar(1:nn-2)
    end function rA

    pure function NewMean(rbar, mat)
        real(wp), intent(in)  :: rbar(:)
        real(wp), intent(in)  :: mat(:, :)
        real(wp), allocatable :: NewMean(:)

        ! local variables
        real(wp), allocatable  :: rA(:),  VAB(:,:)
        real(wp) :: rB(1:2), VB(2,2), VB_inv(2,2), detVB
        integer(ip) :: i, nn, IdSize

        IdSize = 2

        nn = sqrt(real(size(mat),wp))

        allocate(VAB(1:nn-2,1:2), NewMean(1:nn-2), rA(1:nn-2) )

        rB = rbar(nn-1:nn)
        rA = rbar(1:nn-2)

        VAB = mat(1:nn-2,nn-1:nn)
        VB = mat(nn-1:nn,nn-1:nn) + identity(IdSize)
        detVB = VB(1,1)*VB(2,2) - VB(1,2)*VB(2,1)
        VB_inv = reshape((/VB(2,2), -VB(2,1), -VB(1,2), VB(1,1)/), (/2,2/))/detVB

        NewMean(:) = rA - matmul(VAB, matmul(VB_inv,rB))
    end function NewMean

    pure function NewCovMat(mat)
        real(wp), intent(in) :: mat(:,:)
        real(wp), allocatable :: NewCovMat(:,:)

        ! local variables
        real(wp) :: VB(2,2), VB_inv(2,2), detVB
        real(wp), allocatable :: VAB(:,:), VAB_T(:,:), VA(:,:)
        integer(ip) :: i, nn, IdSize

        IdSize = 2

        nn = sqrt(real(size(mat),wp))

        allocate(VAB(1:nn-2,1:2), VAB_T(1:2,1:nn-2), VA(1:nn-2,1:nn-2),NewCovMat(1:nn-2,1:nn-2))

        VA = mat(1:nn-2,1:nn-2)

        VAB = mat(1:nn-2,nn-1:nn)
        VAB_T = mat(nn-1:nn,1:nn-2)

        VB = mat(nn-1:nn,nn-1:nn) + identity(IdSize)
        detVB = VB(1,1)*VB(2,2) - VB(1,2)*VB(2,1)
        VB_inv = reshape((/VB(2,2), -VB(2,1), -VB(1,2), VB(1,1)/), (/2,2/))/detVB

        NewCovMat(:,:) = VA - matmul(VAB, matmul(VB_inv,VAB_T))

        deallocate(VAB, VAB_T, VA)
    end function NewCovMat

    subroutine Compute_q(mat, rbar, q)
        real(wp), intent(in) :: mat(:,:)
        real(wp), intent(in) :: rbar(:)
        real(wp), intent(out) :: q

        ! local variables
        real(wp)    :: VB(2,2), VB_inv(2,2), rbar_B_T(1,1:2), detVB, detVB_inv, tmp(1)
        integer(ip) :: i, nn, IdSize

        real(wp), allocatable :: rbar_B(:)

        nn = sqrt(real(size(mat),wp))

        IdSize = 2

        allocate(rbar_B(1:2))

        rbar_B(1:2) = rbar(nn-1:nn)
        rbar_B_T(1,1:2) = rbar(nn-1:nn)

        VB = mat(nn-1:nn,nn-1:nn) + identity(IdSize)
        detVB = VB(1,1)*VB(2,2) - VB(1,2)*VB(2,1)

        VB_inv = reshape((/VB(2,2), -VB(2,1), -VB(1,2), VB(1,1)/), (/2,2/))/detVB
        detVB_inv = VB_inv(1,1)*VB_inv(2,2) - VB_inv(1,2)*VB_inv(2,1)

        tmp = -matmul(rbar_B_T,matmul(VB_inv, rbar_B))

        q = 2.0_wp*exp(tmp(1))/sqrt(detVB)
    end subroutine Compute_q

    pure function identity(nn)
        integer(ip), intent(in) :: nn
        real(wp) :: identity(1:nn,1:nn)

        ! local variables
        integer(ip) :: i, j

        forall(i=1:nn, j=1:nn) identity(i,j) = (i/j)*(j/i)
    end function identity

end module torontonian_samples

module linpack_q_complex
  use kinds

  implicit none

contains

function iqamax ( n, x, incx )

!*****************************************************************************80
!
!! IQAMAX finds the index of the vector element of maximum absolute value.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    08 April 1999
!
!  Author:
!
!    This FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Charles Lawson, Richard Hanson, David Kincaid, Fred Krogh,
!    Algorithm 539: 
!    Basic Linear Algebra Subprograms for Fortran Usage,
!    ACM Transactions on Mathematical Software,
!    Volume 5, Number 3, September 1979, pages 308-323.
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of entries in the vector.
!
!    Input, real ( kind = qp ) X(*), the vector to be examined.
!
!    Input, integer ( kind = 4 ) INCX, the increment between successive entries of SX.
!
!    Output, integer ( kind = 4 ) IQAMAX, the index of the element of SX of maximum
!    absolute value.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) i
  integer ( kind = 4 ) incx
  integer ( kind = 4 ) iqamax
  integer ( kind = 4 ) ix
  integer ( kind = 4 ) n
  real ( kind = wp ) samax
  real ( kind = wp ) x(*)

  if ( n <= 0 ) then

    iqamax = 0

  else if ( n == 1 ) then

    iqamax = 1

  else if ( incx == 1 ) then

    iqamax = 1
    samax = abs ( x(1) )

    do i = 2, n

      if ( samax < abs ( x(i) ) ) then
        iqamax = i
        samax = abs ( x(i) )
      end if

    end do

  else

    if ( 0 <= incx ) then
      ix = 1
    else
      ix = ( - n + 1 ) * incx + 1
    end if

    iqamax = 1
    samax = abs ( x(ix) )

    ix = ix + incx

    do i = 2, n
      if ( samax < abs ( x(ix) ) ) then
        iqamax = i
        samax = abs ( x(ix) )
      end if
      ix = ix + incx
    end do

  end if

  return
end
subroutine qaxpy ( n, sa, x, incx, y, incy )
  use kinds

!*****************************************************************************80
!
!! QAXPY adds a constant times one vector to another.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    08 April 1999
!
!  Author:
!
!    This FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Charles Lawson, Richard Hanson, David Kincaid, Fred Krogh,
!    Algorithm 539: 
!    Basic Linear Algebra Subprograms for Fortran Usage,
!    ACM Transactions on Mathematical Software,
!    Volume 5, Number 3, September 1979, pages 308-323.
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of entries in the vector.
!
!    Input, real SA, the multiplier.
!
!    Input, real ( kind = qp ) X(*), the vector to be scaled and added to Y.
!
!    Input, integer ( kind = 4 ) INCX, the increment between successive entries of X.
!
!    Input/output, real ( kind = qp ) Y(*), the vector to which a 
!    multiple of X is to be added.
!
!    Input, integer ( kind = 4 ) INCY, the increment between successive entries of Y.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) i
  integer ( kind = 4 ) incx
  integer ( kind = 4 ) incy
  integer ( kind = 4 ) ix
  integer ( kind = 4 ) iy
  integer ( kind = 4 ) n
  real ( kind = wp ) sa
  real ( kind = wp ) x(*)
  real ( kind = wp ) y(*)

  if ( n <= 0 ) then

  else if ( sa == 0.0Q+00 ) then

  else if ( incx == 1 .and. incy == 1 ) then

    y(1:n) = y(1:n) + sa * x(1:n)

  else

    if ( 0 <= incx ) then
      ix = 1
    else
      ix = ( - n + 1 ) * incx + 1
    end if

    if ( 0 <= incy ) then
      iy = 1
    else
      iy = ( - n + 1 ) * incy + 1
    end if

    do i = 1, n
      y(iy) = y(iy) + sa * x(ix)
      ix = ix + incx
      iy = iy + incy
    end do

  end if

  return
end
subroutine qgeco ( a, lda, n, ipvt, rcond, z )
  use kinds

!*****************************************************************************80
!
!! QGECO factors a matrix and estimates its condition number.
!
!  Discussion:
!
!    If RCOND is not needed, QGEFA is slightly faster.
!
!    To solve A * X = B, follow QGECO by QGESL.
!
!    To compute inverse ( A ) * C, follow QGECO by QGESL.
!
!    To compute determinant ( A ), follow QGECO by QGEDI.
!
!    To compute inverse ( A ), follow QGECO by QGEDI.
!
!    For the system A * X = B, relative perturbations in A and B
!    of size EPSILON may cause relative perturbations in X of size
!    EPSILON/RCOND.
!
!    If RCOND is so small that the logical expression
!      1.0 + RCOND == 1.0
!    is true, then A may be singular to working precision.  In particular,
!    RCOND is zero if exact singularity is detected or the estimate
!    underflows.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    15 March 2016
!
!  Author:
!
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!  Parameters:
!
!    Input/output, real ( kind = qp ) A(LDA,N).  On input, a matrix to be
!    factored.  On output, the LU factorization of the matrix.
!
!    Input, integer ( kind = 4 ) LDA, the leading dimension of the array A.
!
!    Input, integer ( kind = 4 ) N, the order of the matrix A.
!
!    Output, integer ( kind = 4 ) IPVT(N), the pivot indices.
!
!    Output, real ( kind = qp ) RCOND, an estimate of the reciprocal
!    condition number of A.
!
!    Output, real ( kind = qp ) Z(N), a work vector whose contents are usually
!    unimportant.  If A is close to a singular matrix, then Z is an
!    approximate null vector in the sense that
!      norm ( A * Z ) = RCOND * norm ( A ) * norm ( Z ).
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) lda
  integer ( kind = 4 ) n

  real ( kind = wp ) a(lda,n)
  real ( kind = wp ) anorm
  real ( kind = wp ) ek
  integer ( kind = 4 ) info
  integer ( kind = 4 ) ipvt(n)
  integer ( kind = 4 ) j
  integer ( kind = 4 ) k
  integer ( kind = 4 ) l
  real ( kind = wp ) rcond
  real ( kind = wp ) s
  real ( kind = wp ) sm
  real ( kind = wp ) t
  real ( kind = wp ) wk
  real ( kind = wp ) wkm
  real ( kind = wp ) ynorm
  real ( kind = wp ) z(n)
!
!  Compute the L1 norm of A.
!
  anorm = 0.0Q+00
  do j = 1, n
    anorm = max ( anorm, sum ( abs ( a(1:n,j) ) ) )
  end do
!
!  Compute the LU factorization.
!
  call qgefa ( a, lda, n, ipvt, info )
!
!  RCOND = 1 / ( norm(A) * (estimate of norm(inverse(A))) )
!
!  estimate of norm(inverse(A)) = norm(Z) / norm(Y)
!
!  where
!    A * Z = Y
!  and
!    A' * Y = E
!
!  The components of E are chosen to cause maximum local growth in the
!  elements of W, where U'*W = E.  The vectors are frequently rescaled
!  to avoid overflow.
!
!  Solve U' * W = E.
!
  ek = 1.0Q+00
  z(1:n) = 0.0Q+00

  do k = 1, n

    if ( z(k) /= 0.0Q+00 ) then
      ek = sign ( ek, - z(k) )
    end if

    if ( abs ( a(k,k) ) < abs ( ek - z(k) ) ) then
      s = abs ( a(k,k) ) / abs ( ek - z(k) )
      z(1:n) = s * z(1:n)
      ek = s * ek
    end if

    wk = ek - z(k)
    wkm = - ek - z(k)
    s = abs ( wk )
    sm = abs ( wkm )

    if ( a(k,k) /= 0.0Q+00 ) then
      wk = wk / a(k,k)
      wkm = wkm / a(k,k)
    else
      wk = 1.0Q+00
      wkm = 1.0Q+00
    end if

    if ( k + 1 <= n ) then

      do j = k + 1, n
        sm = sm + abs ( z(j) + wkm * a(k,j) )
        z(j) = z(j) + wk * a(k,j)
        s = s + abs ( z(j) )
      end do

      if ( s < sm ) then
        t = wkm - wk
        wk = wkm
        z(k+1:n) = z(k+1:n) + t * a(k,k+1:n)
      end if

    end if

    z(k) = wk

  end do

  z(1:n) = z(1:n) / sum ( abs ( z(1:n) ) )
!
!  Solve L' * Y = W
!
  do k = n, 1, -1

    z(k) = z(k) + dot_product ( a(k+1:n,k), z(k+1:n) )

    if ( 1.0Q+00 < abs ( z(k) ) ) then
      z(1:n) = z(1:n) / abs ( z(k) )
    end if

    l = ipvt(k)

    t    = z(l)
    z(l) = z(k)
    z(k) = t

  end do

  z(1:n) = z(1:n) / sum ( abs ( z(1:n) ) )

  ynorm = 1.0Q+00
!
!  Solve L * V = Y.
!
  do k = 1, n

    l = ipvt(k)

    t    = z(l)
    z(l) = z(k)
    z(k) = t

    z(k+1:n) = z(k+1:n) + t * a(k+1:n,k)

    if ( 1.0Q+00 < abs ( z(k) ) ) then
      ynorm = ynorm / abs ( z(k) )
      z(1:n) = z(1:n) / abs ( z(k) )
    end if

  end do

  s = sum ( abs ( z(1:n) ) )
  z(1:n) = z(1:n) / s
  ynorm = ynorm / s
!
!  Solve U * Z = V.
!
  do k = n, 1, -1

    if ( abs ( a(k,k) ) < abs ( z(k) ) ) then
      s = abs ( a(k,k) ) / abs ( z(k) )
      z(1:n) = s * z(1:n)
      ynorm = s * ynorm
    end if

    if ( a(k,k) /= 0.0Q+00 ) then
      z(k) = z(k) / a(k,k)
    else
      z(k) = 1.0Q+00
    end if

    z(1:k-1) = z(1:k-1) - z(k) * a(1:k-1,k)

  end do
!
!  Normalize Z in the L1 norm.
!
  s = 1.0Q+00 / sum ( abs ( z(1:n) ) )
  z(1:n) = s * z(1:n)
  ynorm = s * ynorm

  if ( anorm /= 0.0Q+00 ) then
    rcond = ynorm / anorm
  else
    rcond = 0.0Q+00
  end if

  return
end
subroutine qgedi ( a, lda, n, ipvt, det, work, job )
  use kinds

!*****************************************************************************80
!
!! QGEDI: determinant and inverse of a matrix factored by QGECO or QGEFA.
!
!  Discussion:
!
!    A division by zero will occur if the input factor contains
!    a zero on the diagonal and the inverse is requested.
!    It will not occur if the subroutines are called correctly
!    and if QGECO has set 0.0 < RCOND or QGEFA has set INFO == 0.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    15 March 2016
!
!  Author:
!
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!  Parameters:
!
!    Input/output, real ( kind = qp ) A(LDA,N), on input, the  LU factor
!    information, as output by QGECO or QGEFA.  On output, the inverse
!    matrix, if requested.
!
!    Input, integer ( kind = 4 ) LDA, the leading dimension of the array A.
!
!    Input, integer ( kind = 4 ) N, the order of the matrix A.
!
!    Input, integer ( kind = 4 ) IPVT(N), the pivot vector from QGECO or QGEFA.
!
!    Workspace, real ( kind = qp ) WORK(N).
!
!    Output, real ( kind = qp ) DET(2), the determinant of original matrix if
!    requested.  The determinant = DET(1) * 10.0**DET(2)
!    with  1.0 <= abs ( DET(1) ) < 10.0
!    or DET(1) == 0.0.
!
!    Input, integer ( kind = 4 ) JOB, specifies what is to be computed.
!    11, both determinant and inverse.
!    01, inverse only.
!    10, determinant only.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) lda
  integer ( kind = 4 ) n

  real ( kind = wp ) a(lda,n)
  real ( kind = wp ) det(2)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ipvt(n)
  integer ( kind = 4 ) j
  integer ( kind = 4 ) job
  integer ( kind = 4 ) k
  integer ( kind = 4 ) l
  real ( kind = wp ) t
  real ( kind = wp ) work(n)
!
!  Compute the determinant.
!
  if ( job / 10 /= 0 ) then

    det(1) = 1.0Q+00
    det(2) = 0.0Q+00

    do i = 1, n

      if ( ipvt(i) /= i ) then
        det(1) = -det(1)
      end if

      det(1) = det(1) * a(i,i)

      if ( det(1) == 0.0Q+00 ) then
        exit
      end if

      do while ( abs ( det(1) ) < 1.0Q+00 )
        det(1) = det(1) * 10.0Q+00
        det(2) = det(2) - 1.0Q+00
      end do

      do while ( 10.0Q+00 <= abs ( det(1) ) )
        det(1) = det(1) / 10.0Q+00
        det(2) = det(2) + 1.0Q+00
      end do

    end do

  end if
!
!  Compute inverse(U).
!
  if ( mod ( job, 10 ) /= 0 ) then

    do k = 1, n

      a(k,k) = 1.0Q+00 / a(k,k)
      t = - a(k,k)
      call qscal ( k-1, t, a(1,k), 1 )

      do j = k + 1, n
        t = a(k,j)
        a(k,j) = 0.0Q+00
        call qaxpy ( k, t, a(1,k), 1, a(1,j), 1 )
      end do

    end do
!
!  Form inverse(U) * inverse(L).
!
    do k = n - 1, 1, -1

      work(k+1:n) = a(k+1:n,k)

      a(k+1:n,k) = 0.0Q+00

      do j = k + 1, n
        t = work(j)
        call qaxpy ( n, t, a(1,j), 1, a(1,k), 1 )
      end do

      l = ipvt(k)
      if ( l /= k ) then
        call qswap ( n, a(1,k), 1, a(1,l), 1 )
      end if

    end do

  end if

  return
end
subroutine qgefa ( a, lda, n, ipvt, info )
  use kinds

!*****************************************************************************80
!
!! QGEFA factors a real matrix.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    07 March 2001
!
!  Author:
!
!    This FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!  Parameters:
!
!    Input/output, real ( kind = qp ) A(LDA,N).
!    On intput, the matrix to be factored.
!    On output, an upper triangular matrix and the multipliers used to obtain
!    it.  The factorization can be written A=L*U, where L is a product of
!    permutation and unit lower triangular matrices, and U is upper triangular.
!
!    Input, integer ( kind = 4 ) LDA, the leading dimension of A.
!
!    Input, integer ( kind = 4 ) N, the order of the matrix A.
!
!    Output, integer ( kind = 4 ) IPVT(N), the pivot indices.
!
!    Output, integer ( kind = 4 ) INFO, singularity indicator.
!    0, normal value.
!    K, if U(K,K) == 0.  This is not an error condition for this subroutine,
!    but it does indicate that QGESL or QGEDI will divide by zero if called.
!    Use RCOND in QGECO for a reliable indication of singularity.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) lda
  integer ( kind = 4 ) n

  real ( kind = wp ) a(lda,n)
  integer ( kind = 4 ) info
  integer ( kind = 4 ) ipvt(n)
  !integer ( kind = 4 ) iqamax
  integer ( kind = 4 ) j
  integer ( kind = 4 ) k
  integer ( kind = 4 ) l
  real ( kind = wp ) t
!
!  Gaussian elimination with partial pivoting.
!
  info = 0

  do k = 1, n - 1
!
!  Find L = pivot index.
!
    l = iqamax ( n - k + 1, a(k,k), 1 ) + k - 1
    ipvt(k) = l
!
!  Zero pivot implies this column already triangularized.
!
    if ( a(l,k) == 0.0Q+00 ) then
      info = k
      cycle
    end if
!
!  Interchange if necessary.
!
    if ( l /= k ) then
      t      = a(l,k)
      a(l,k) = a(k,k)
      a(k,k) = t
    end if
!
!  Compute multipliers.
!
    a(k+1:n,k) = - a(k+1:n,k) / a(k,k)
!
!  Row elimination with column indexing.
!
    do j = k + 1, n
      t = a(l,j)
      if ( l /= k ) then
        a(l,j) = a(k,j)
        a(k,j) = t
      end if
      call qaxpy ( n - k, t, a(k+1,k), 1, a(k+1,j), 1 )
    end do

  end do

  ipvt(n) = n

  if ( a(n,n) == 0.0Q+00 ) then
    info = n
  end if

  return
end
subroutine qgesl ( a, lda, n, ipvt, b, job )
  use kinds

!*****************************************************************************80
!
!! QGESL solves a real general linear system A * X = B.
!
!  Discussion:
!
!    QGESL can solve either of the systems A * X = B or A' * X = B.
!
!    The system matrix must have been factored by QGECO or QGEFA.
!
!    A division by zero will occur if the input factor contains a
!    zero on the diagonal.  Technically this indicates singularity
!    but it is often caused by improper arguments or improper
!    setting of LDA.  It will not occur if the subroutines are
!    called correctly and if QGECO has set 0.0 < RCOND 
!    or QGEFA has set INFO == 0.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    07 March 2001
!
!  Author:
!
!    This FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!  Parameters:
!
!    Input, real ( kind = qp ) A(LDA,N), the output from QGECO or QGEFA.
!
!    Input, integer ( kind = 4 ) LDA, the leading dimension of A.
!
!    Input, integer ( kind = 4 ) N, the order of the matrix A.
!
!    Input, integer ( kind = 4 ) IPVT(N), the pivot vector from QGECO or QGEFA.
!
!    Input/output, real ( kind = qp ) B(N).
!    On input, the right hand side vector.
!    On output, the solution vector.
!
!    Input, integer ( kind = 4 ) JOB.
!    0, solve A * X = B;
!    nonzero, solve A' * X = B.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) lda
  integer ( kind = 4 ) n

  real ( kind = wp ) a(lda,n)
  real ( kind = wp ) b(n)
  integer ( kind = 4 ) ipvt(n)
  integer ( kind = 4 ) job
  integer ( kind = 4 ) k
  integer ( kind = 4 ) l
  real ( kind = wp ) t
!
!  Solve A * X = B.
!
  if ( job == 0 ) then

    do k = 1, n - 1

      l = ipvt(k)
      t = b(l)

      if ( l /= k ) then
        b(l) = b(k)
        b(k) = t
      end if

      call qaxpy ( n - k, t, a(k+1,k), 1, b(k+1), 1 )

    end do

    do k = n, 1, -1
      b(k) = b(k) / a(k,k)
      t = - b(k)
      call qaxpy ( k - 1, t, a(1,k), 1, b(1), 1 )
    end do

  else
!
!  Solve A' * X = B.
!
    do k = 1, n
      t = dot_product ( a(1:k-1,k), b(1:k-1) )
      b(k) = ( b(k) - t ) / a(k,k)
    end do

    do k = n - 1, 1, -1

      b(k) = b(k) + dot_product ( a(k+1:n,k), b(k+1:n) )
      l = ipvt(k)

      if ( l /= k ) then
        t    = b(l)
        b(l) = b(k)
        b(k) = t
      end if

    end do

  end if

  return
end
subroutine qscal ( n, sa, x, incx )
  use kinds

!*****************************************************************************80
!
!! QSCAL scales a vector by a constant.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    15 March 2016
!
!  Author:
!
!    Original FORTRAN77 version by Charles Lawson, Richard Hanson, 
!    David Kincaid, Fred Krogh.
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!    Charles Lawson, Richard Hanson, David Kincaid, Fred Krogh,
!    Algorithm 539, 
!    Basic Linear Algebra Subprograms for Fortran Usage,
!    ACM Transactions on Mathematical Software,
!    Volume 5, Number 3, September 1979, pages 308-323.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of entries in the vector.
!
!    Input, real ( kind = qp ) SA, the multiplier.
!
!    Input/output, real ( kind = qp ) X(*), the vector to be scaled.
!
!    Input, integer ( kind = 4 ) INCX, the increment between successive 
!    entries of X.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) i
  integer ( kind = 4 ) incx
  integer ( kind = 4 ) ix
  integer ( kind = 4 ) m
  integer ( kind = 4 ) n
  real ( kind = wp ) sa
  real ( kind = wp ) x(*)

  if ( n <= 0 ) then

  else if ( incx == 1 ) then

    m = mod ( n, 5 )

    x(1:m) = sa * x(1:m)

    do i = m + 1, n, 5
      x(i)   = sa * x(i)
      x(i+1) = sa * x(i+1)
      x(i+2) = sa * x(i+2)
      x(i+3) = sa * x(i+3)
      x(i+4) = sa * x(i+4)
    end do

  else

    if ( 0 <= incx ) then
      ix = 1
    else
      ix = ( - n + 1 ) * incx + 1
    end if

    do i = 1, n
      x(ix) = sa * x(ix)
      ix = ix + incx
    end do

  end if

  return
end
subroutine qswap ( n, x, incx, y, incy )
  use kinds

!*****************************************************************************80
!
!! QSWAP interchanges two vectors.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    15 March 2016
!
!  Author:
!
!    This FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!    Charles Lawson, Richard Hanson, David Kincaid, Fred Krogh,
!    Algorithm 539, 
!    Basic Linear Algebra Subprograms for Fortran Usage,
!    ACM Transactions on Mathematical Software, 
!    Volume 5, Number 3, September 1979, pages 308-323.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of entries in the vectors.
!
!    Input/output, real ( kind = qp ) X(*), one of the vectors to swap.
!
!    Input, integer ( kind = 4 ) INCX, the increment between successive 
!    entries of X.
!
!    Input/output, real ( kind = qp ) Y(*), one of the vectors to swap.
!
!    Input, integer ( kind = 4 ) INCY, the increment between successive 
!    elements of Y.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) i
  integer ( kind = 4 ) incx
  integer ( kind = 4 ) incy
  integer ( kind = 4 ) ix
  integer ( kind = 4 ) iy
  integer ( kind = 4 ) m
  integer ( kind = 4 ) n
  real ( kind = wp ) temp
  real ( kind = wp ) x(*)
  real ( kind = wp ) y(*)

  if ( n <= 0 ) then

  else if ( incx == 1 .and. incy == 1 ) then

    m = mod ( n, 3 )

    do i = 1, m
      temp = x(i)
      x(i) = y(i)
      y(i) = temp
    end do

    do i = m + 1, n, 3

      temp = x(i)
      x(i) = y(i)
      y(i) = temp

      temp = x(i+1)
      x(i+1) = y(i+1)
      y(i+1) = temp

      temp = x(i+2)
      x(i+2) = y(i+2)
      y(i+2) = temp

    end do

  else

    if ( 0 <= incx ) then
      ix = 1
    else
      ix = ( - n + 1 ) * incx + 1
    end if

    if ( 0 <= incy ) then
      iy = 1
    else
      iy = ( - n + 1 ) * incy + 1
    end if

    do i = 1, n
      temp = x(ix)
      x(ix) = y(iy)
      y(iy) = temp
      ix = ix + incx
      iy = iy + incy
    end do

  end if

  return
end


function iqamax_complex ( n, x, incx )

!*****************************************************************************80
!
!! IQAMAX finds the index of the vector element of maximum absolute value.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    08 April 1999
!
!  Author:
!
!    This FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Charles Lawson, Richard Hanson, David Kincaid, Fred Krogh,
!    Algorithm 539: 
!    Basic Linear Algebra Subprograms for Fortran Usage,
!    ACM Transactions on Mathematical Software,
!    Volume 5, Number 3, September 1979, pages 308-323.
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of entries in the vector.
!
!    Input, real ( kind = qp ) X(*), the vector to be examined.
!
!    Input, integer ( kind = 4 ) INCX, the increment between successive entries of SX.
!
!    Output, integer ( kind = 4 ) IQAMAX, the index of the element of SX of maximum
!    absolute value.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) i
  integer ( kind = 4 ) incx
  integer ( kind = 4 ) iqamax_complex
  integer ( kind = 4 ) ix
  integer ( kind = 4 ) n
  real ( kind = wp ) samax
  complex ( kind = wp ) x(*)

  if ( n <= 0 ) then

    iqamax_complex = 0

  else if ( n == 1 ) then

    iqamax_complex = 1

  else if ( incx == 1 ) then

    iqamax_complex = 1
    samax = abs ( x(1) )

    do i = 2, n

      if ( samax < abs ( x(i) ) ) then
        iqamax_complex = i
        samax = abs ( x(i) )
      end if

    end do

  else

    if ( 0 <= incx ) then
      ix = 1
    else
      ix = ( - n + 1 ) * incx + 1
    end if

    iqamax_complex = 1
    samax = abs ( x(ix) )

    ix = ix + incx

    do i = 2, n
      if ( samax < abs ( x(ix) ) ) then
        iqamax_complex = i
        samax = abs ( x(ix) )
      end if
      ix = ix + incx
    end do

  end if

  return
end
subroutine qaxpy_complex ( n, sa, x, incx, y, incy )
  use kinds

!*****************************************************************************80
!
!! QAXPY adds a constant times one vector to another.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    08 April 1999
!
!  Author:
!
!    This FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Charles Lawson, Richard Hanson, David Kincaid, Fred Krogh,
!    Algorithm 539: 
!    Basic Linear Algebra Subprograms for Fortran Usage,
!    ACM Transactions on Mathematical Software,
!    Volume 5, Number 3, September 1979, pages 308-323.
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of entries in the vector.
!
!    Input, real SA, the multiplier.
!
!    Input, real ( kind = qp ) X(*), the vector to be scaled and added to Y.
!
!    Input, integer ( kind = 4 ) INCX, the increment between successive entries of X.
!
!    Input/output, real ( kind = qp ) Y(*), the vector to which a 
!    multiple of X is to be added.
!
!    Input, integer ( kind = 4 ) INCY, the increment between successive entries of Y.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) i
  integer ( kind = 4 ) incx
  integer ( kind = 4 ) incy
  integer ( kind = 4 ) ix
  integer ( kind = 4 ) iy
  integer ( kind = 4 ) n
  complex ( kind = wp ) sa
  complex ( kind = wp ) x(*)
  complex ( kind = wp ) y(*)

  if ( n <= 0 ) then

  else if ( sa == 0.0Q+00 ) then

  else if ( incx == 1 .and. incy == 1 ) then

    y(1:n) = y(1:n) + sa * x(1:n)

  else

    if ( 0 <= incx ) then
      ix = 1
    else
      ix = ( - n + 1 ) * incx + 1
    end if

    if ( 0 <= incy ) then
      iy = 1
    else
      iy = ( - n + 1 ) * incy + 1
    end if

    do i = 1, n
      y(iy) = y(iy) + sa * x(ix)
      ix = ix + incx
      iy = iy + incy
    end do

  end if

  return
end
subroutine qgedi_complex ( a, lda, n, ipvt, det, work, job )
  use kinds

!*****************************************************************************80
!
!! QGEDI: determinant and inverse of a matrix factored by QGECO or QGEFA.
!
!  Discussion:
!
!    A division by zero will occur if the input factor contains
!    a zero on the diagonal and the inverse is requested.
!    It will not occur if the subroutines are called correctly
!    and if QGECO has set 0.0 < RCOND or QGEFA has set INFO == 0.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    15 March 2016
!
!  Author:
!
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!  Parameters:
!
!    Input/output, real ( kind = qp ) A(LDA,N), on input, the  LU factor
!    information, as output by QGECO or QGEFA.  On output, the inverse
!    matrix, if requested.
!
!    Input, integer ( kind = 4 ) LDA, the leading dimension of the array A.
!
!    Input, integer ( kind = 4 ) N, the order of the matrix A.
!
!    Input, integer ( kind = 4 ) IPVT(N), the pivot vector from QGECO or QGEFA.
!
!    Workspace, real ( kind = qp ) WORK(N).
!
!    Output, real ( kind = qp ) DET(2), the determinant of original matrix if
!    requested.  The determinant = DET(1) * 10.0**DET(2)
!    with  1.0 <= abs ( DET(1) ) < 10.0
!    or DET(1) == 0.0.
!
!    Input, integer ( kind = 4 ) JOB, specifies what is to be computed.
!    11, both determinant and inverse.
!    01, inverse only.
!    10, determinant only.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) lda
  integer ( kind = 4 ) n

  complex ( kind = wp ) a(lda,n)
  complex ( kind = wp ) det(2)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ipvt(n)
  integer ( kind = 4 ) j
  integer ( kind = 4 ) job
  integer ( kind = 4 ) k
  integer ( kind = 4 ) l
  complex ( kind = wp ) t
  complex ( kind = wp ) work(n)
!
!  Compute the determinant.
!
  if ( job / 10 /= 0 ) then

    det(1) = 1.0Q+00
    det(2) = 0.0Q+00

    do i = 1, n

      if ( ipvt(i) /= i ) then
        det(1) = -det(1)
      end if

      det(1) = det(1) * a(i,i)

      if ( det(1) == 0.0Q+00 ) then
        exit
      end if

      do while ( abs ( det(1) ) < 1.0Q+00 )
        det(1) = det(1) * 10.0Q+00
        det(2) = det(2) - 1.0Q+00
      end do

      do while ( 10.0Q+00 <= abs ( det(1) ) )
        det(1) = det(1) / 10.0Q+00
        det(2) = det(2) + 1.0Q+00
      end do

    end do

  end if
!
!  Compute inverse(U).
!
  if ( mod ( job, 10 ) /= 0 ) then

    do k = 1, n

      a(k,k) = 1.0Q+00 / a(k,k)
      t = - a(k,k)
      call qscal_complex ( k-1, t, a(1,k), 1 )

      do j = k + 1, n
        t = a(k,j)
        a(k,j) = 0.0Q+00
        call qaxpy_complex ( k, t, a(1,k), 1, a(1,j), 1 )
      end do

    end do
!
!  Form inverse(U) * inverse(L).
!
    do k = n - 1, 1, -1

      work(k+1:n) = a(k+1:n,k)

      a(k+1:n,k) = 0.0Q+00

      do j = k + 1, n
        t = work(j)
        call qaxpy_complex ( n, t, a(1,j), 1, a(1,k), 1 )
      end do

      l = ipvt(k)
      if ( l /= k ) then
        call qswap_complex ( n, a(1,k), 1, a(1,l), 1 )
      end if

    end do

  end if

  return
end
subroutine qgefa_complex ( a, lda, n, ipvt, info )
  use kinds

!*****************************************************************************80
!
!! QGEFA factors a real matrix.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    07 March 2001
!
!  Author:
!
!    This FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!  Parameters:
!
!    Input/output, real ( kind = qp ) A(LDA,N).
!    On intput, the matrix to be factored.
!    On output, an upper triangular matrix and the multipliers used to obtain
!    it.  The factorization can be written A=L*U, where L is a product of
!    permutation and unit lower triangular matrices, and U is upper triangular.
!
!    Input, integer ( kind = 4 ) LDA, the leading dimension of A.
!
!    Input, integer ( kind = 4 ) N, the order of the matrix A.
!
!    Output, integer ( kind = 4 ) IPVT(N), the pivot indices.
!
!    Output, integer ( kind = 4 ) INFO, singularity indicator.
!    0, normal value.
!    K, if U(K,K) == 0.  This is not an error condition for this subroutine,
!    but it does indicate that QGESL or QGEDI will divide by zero if called.
!    Use RCOND in QGECO for a reliable indication of singularity.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) lda
  integer ( kind = 4 ) n

  complex ( kind = wp ) a(lda,n)
  integer ( kind = 4 ) info
  integer ( kind = 4 ) ipvt(n)
  !integer ( kind = 4 ) iqamax
  integer ( kind = 4 ) j
  integer ( kind = 4 ) k
  integer ( kind = 4 ) l
  complex ( kind = wp ) t
!
!  Gaussian elimination with partial pivoting.
!
  info = 0

  do k = 1, n - 1
!
!  Find L = pivot index.
!
    l = iqamax_complex ( n - k + 1, a(k,k), 1 ) + k - 1
    ipvt(k) = l
!
!  Zero pivot implies this column already triangularized.
!
    if ( a(l,k) == 0.0Q+00 ) then
      info = k
      cycle
    end if
!
!  Interchange if necessary.
!
    if ( l /= k ) then
      t      = a(l,k)
      a(l,k) = a(k,k)
      a(k,k) = t
    end if
!
!  Compute multipliers.
!
    a(k+1:n,k) = - a(k+1:n,k) / a(k,k)
!
!  Row elimination with column indexing.
!
    do j = k + 1, n
      t = a(l,j)
      if ( l /= k ) then
        a(l,j) = a(k,j)
        a(k,j) = t
      end if
      call qaxpy_complex ( n - k, t, a(k+1,k), 1, a(k+1,j), 1 )
    end do

  end do

  ipvt(n) = n

  if ( a(n,n) == 0.0Q+00 ) then
    info = n
  end if

  return
end
subroutine qscal_complex ( n, sa, x, incx )
  use kinds

!*****************************************************************************80
!
!! QSCAL scales a vector by a constant.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    15 March 2016
!
!  Author:
!
!    Original FORTRAN77 version by Charles Lawson, Richard Hanson, 
!    David Kincaid, Fred Krogh.
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!    Charles Lawson, Richard Hanson, David Kincaid, Fred Krogh,
!    Algorithm 539, 
!    Basic Linear Algebra Subprograms for Fortran Usage,
!    ACM Transactions on Mathematical Software,
!    Volume 5, Number 3, September 1979, pages 308-323.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of entries in the vector.
!
!    Input, real ( kind = qp ) SA, the multiplier.
!
!    Input/output, real ( kind = qp ) X(*), the vector to be scaled.
!
!    Input, integer ( kind = 4 ) INCX, the increment between successive 
!    entries of X.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) i
  integer ( kind = 4 ) incx
  integer ( kind = 4 ) ix
  integer ( kind = 4 ) m
  integer ( kind = 4 ) n
  complex ( kind = wp ) sa
  complex ( kind = wp ) x(*)

  if ( n <= 0 ) then

  else if ( incx == 1 ) then

    m = mod ( n, 5 )

    x(1:m) = sa * x(1:m)

    do i = m + 1, n, 5
      x(i)   = sa * x(i)
      x(i+1) = sa * x(i+1)
      x(i+2) = sa * x(i+2)
      x(i+3) = sa * x(i+3)
      x(i+4) = sa * x(i+4)
    end do

  else

    if ( 0 <= incx ) then
      ix = 1
    else
      ix = ( - n + 1 ) * incx + 1
    end if

    do i = 1, n
      x(ix) = sa * x(ix)
      ix = ix + incx
    end do

  end if

  return
end
subroutine qswap_complex ( n, x, incx, y, incy )
  use kinds

!*****************************************************************************80
!
!! QSWAP interchanges two vectors.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    15 March 2016
!
!  Author:
!
!    This FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Jack Dongarra, Jim Bunch, Cleve Moler, Pete Stewart,
!    LINPACK User's Guide,
!    SIAM, 1979,
!    ISBN13: 978-0-898711-72-1,
!    LC: QA214.L56.
!
!    Charles Lawson, Richard Hanson, David Kincaid, Fred Krogh,
!    Algorithm 539, 
!    Basic Linear Algebra Subprograms for Fortran Usage,
!    ACM Transactions on Mathematical Software, 
!    Volume 5, Number 3, September 1979, pages 308-323.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of entries in the vectors.
!
!    Input/output, real ( kind = qp ) X(*), one of the vectors to swap.
!
!    Input, integer ( kind = 4 ) INCX, the increment between successive 
!    entries of X.
!
!    Input/output, real ( kind = qp ) Y(*), one of the vectors to swap.
!
!    Input, integer ( kind = 4 ) INCY, the increment between successive 
!    elements of Y.
!
  implicit none

!  integer, parameter :: qp = selected_real_kind ( 20, 199 )

  integer ( kind = 4 ) i
  integer ( kind = 4 ) incx
  integer ( kind = 4 ) incy
  integer ( kind = 4 ) ix
  integer ( kind = 4 ) iy
  integer ( kind = 4 ) m
  integer ( kind = 4 ) n
  complex ( kind = wp ) temp
  complex ( kind = wp ) x(*)
  complex ( kind = wp ) y(*)

  if ( n <= 0 ) then

  else if ( incx == 1 .and. incy == 1 ) then

    m = mod ( n, 3 )

    do i = 1, m
      temp = x(i)
      x(i) = y(i)
      y(i) = temp
    end do

    do i = m + 1, n, 3

      temp = x(i)
      x(i) = y(i)
      y(i) = temp

      temp = x(i+1)
      x(i+1) = y(i+1)
      y(i+1) = temp

      temp = x(i+2)
      x(i+2) = y(i+2)
      y(i+2) = temp

    end do

  else

    if ( 0 <= incx ) then
      ix = 1
    else
      ix = ( - n + 1 ) * incx + 1
    end if

    if ( 0 <= incy ) then
      iy = 1
    else
      iy = ( - n + 1 ) * incy + 1
    end if

    do i = 1, n
      temp = x(ix)
      x(ix) = y(iy)
      y(iy) = temp
      ix = ix + incx
      iy = iy + incy
    end do

  end if

  return
end

end module linpack_q_complex

! Copyright 2019 Xanadu Quantum Technologies Inc.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module perm
    ! Module to compute the permanent of a matrix based on Ryser's formula with Gray code implementation.
    ! Subroutines 're' and 'comp' are respectively for real and complex matrices. 
    ! The algorithm has the complexity n*2^n with Gray code implementation. We
    ! use OpenMP parallelization to take advantage of share memory parallelism. When
    ! implemented in double precision, numerical errors become as large as 100% for a
    ! 30x30 matrix. This stems from summation of ~2^30 double precision numbers. In
    ! order to avoid this, we have also implemented the algorithm in quad precision
    ! which can be availed by changing wp = qp from wp = dp in kinds.f90 and compiling
    ! the program again. 

    use kinds
    use vars
    use omp_lib
    implicit none

    contains

    subroutine re(matin, permanent_out)
        ! Computing permanent of a real matrix
        real(dp), intent(in)    :: matin(:, :)
        real(dp), intent(out)   :: permanent_out

        real(wp), allocatable    :: mat(:, :)
        real(wp)   :: permanent

        ! local variables
        real(wp), dimension(:), allocatable :: tmp
        real(wp)    :: permtmp, rowsumprod
        integer(ip2) :: C, k, kg1, kg2, cntr, &
                                     j, pos, sig, sgntmp, i, n

        integer(ip) :: nmaxthreads, nthreads, ii

        integer(ip2), allocatable :: threadbound_low(:), threadbound_hi(:)
        real(wp), allocatable    :: tot(:)
        real(dp), allocatable    :: chitmp(:)

        !f2py intent(in) :: matin
        !f2py intent(out) :: permanent_out

#ifdef _OPENMP
        nthreads = OMP_get_max_threads()
        call omp_set_num_threads(nthreads)
#else
        nthreads = 1
#endif

        n = nint(sqrt(real(size(matin), wp)))
        allocate(mat(1:n, 1:n))

        mat = real(matin, wp)
        nmaxthreads = nthreads


        C = 2**n-1

        nmaxthreads = nthreads


        allocate(tot(1:nmaxthreads),threadbound_low(1:nmaxthreads),threadbound_hi(1:nmaxthreads),chitmp(1:n+1), tmp(1:n))

        do i=1,nmaxthreads
            threadbound_low(i) = int(C/nmaxthreads)*(i-1)+1
            threadbound_hi(i) = int(C/nmaxthreads)*i
        end do
            threadbound_hi(nmaxthreads) =  C


        tot=0.0_wp

!$OMP PARALLEL DO private(ii,j,k,rowsumprod,kg2,sgntmp,sig,pos,tmp,permtmp,chitmp,cntr) shared(mat,tot)
        do ii = 1,nmaxthreads


            permtmp = 0.0_wp
            tmp = 0.0_wp
            chitmp = 0
            cntr = 0
            kg1 = 0

            do k = threadbound_low(ii), threadbound_hi(ii)
                rowsumprod = 1.0_wp
                kg2 = igray(k, 1_ip2)
                sgntmp = kg2-igray(k-1_ip2, 1_ip2)
                sig = sign(1_ip2, sgntmp)! sgntmp/abs(sgntmp)
                pos = 0

                do while(ibits(sgntmp, pos, 1) < 1)
                     pos = pos+1
                end do
                pos = n-pos


                if (k == threadbound_low(ii)) then
                    call dec2bin(kg2, n, chitmp)

                    do j=1,n
                        tmp(j) = tmp(j) + sum(chitmp(1:n) * mat(1:n,j))
                        rowsumprod = rowsumprod * tmp(j)
                    end do

                    cntr = int(chitmp(n+1), ip)

                else

                    cntr = cntr+sig

                    do j=1,n

                        if (sig < 0) then
                            tmp(j) = tmp(j) - mat(pos, j)!sign(mat(pos, j), sgntmp)
                        else
                            tmp(j) = tmp(j) + mat(pos, j)!sign(mat(pos, j), sgntmp)
                        end if

                        rowsumprod = rowsumprod * tmp(j)
                    end do

                end if


                if(mod(n-cntr,2)==0) then
                    permtmp = permtmp + rowsumprod
                else
                    permtmp = permtmp - rowsumprod
                end if

            end do

            tot(ii) = permtmp

        end do
!$OMP END PARALLEL DO

        permanent = sum(tot)
        permanent_out = real(permanent, dp)

        deallocate(tot,threadbound_low,threadbound_hi,chitmp,tmp)
    end subroutine re

    subroutine comp(matin, permanent_out)
        ! Computing permanent of a complex matrix
        complex(dp), intent(in)   :: matin(:, :)
        complex(dp), intent(out) :: permanent_out  

        complex(wp), allocatable :: mat(:, :)
        complex(wp) :: permanent

        ! local variables
        complex(wp) :: permtmp, rowsumprod
        integer(ip2) :: C, k, kg1, kg2, cntr, &
                                     j, pos, sig, sgntmp, i, n

        integer(ip) :: nmaxthreads, nthreads, ii

        integer(ip2), allocatable :: threadbound_low(:), threadbound_hi(:)


        real(dp), allocatable    :: chitmp(:)
        complex(wp), allocatable :: tot(:), tmp(:)

        !f2py intent(in) :: mat
        !f2py intent(out) :: permanent_out

#ifdef _OPENMP
        nthreads = OMP_get_max_threads()
        call omp_set_num_threads(nthreads)
#else
        nthreads = 1
#endif

        n = nint(sqrt(real(size(matin), wp)))
        allocate(mat(1:n, 1:n))

        mat = real(matin, wp) + zi*real(aimag(matin), wp)

        nmaxthreads = nthreads

        C = 2**n-1

        nmaxthreads = nthreads

        allocate(tot(1:nmaxthreads), threadbound_low(1:nmaxthreads), &
            threadbound_hi(1:nmaxthreads), chitmp(1:n+1), tmp(1:n))

        do i=1,nmaxthreads
            threadbound_low(i) = int(C/nmaxthreads)*(i-1)+1
            threadbound_hi(i) = int(C/nmaxthreads)*i
        end do
            threadbound_hi(nmaxthreads) = C

        tot = zzero
        chitmp = 0

!$OMP PARALLEL DO private(ii,j,k,rowsumprod,kg2,sgntmp,sig,pos,tmp,permtmp,chitmp,cntr) shared(mat,tot)
        do ii=1, nmaxthreads

            permtmp = zzero
            tmp = zzero
            cntr = 0
            kg1 = 0
            do k=threadbound_low(ii), threadbound_hi(ii)

                rowsumprod = zone
                kg2 = igray(k, 1_ip2)
                sgntmp = kg2-igray(k-1_ip2, 1_ip2)
                sig = sign(1_ip2, sgntmp)! sgntmp/abs(sgntmp)
                pos = 0

                do while(ibits(sgntmp, pos, 1) < 1)
                     pos = pos+1
                end do
                pos = n-pos


                if (k == threadbound_low(ii)) then
                    call dec2bin(kg2, n, chitmp)

                    do j=1, n
                        tmp(j) = tmp(j) + sum(chitmp(1:n) * mat(1:n,j))

                        rowsumprod = rowsumprod * tmp(j)
                    end do

                    cntr = int(chitmp(n+1), ip)

                else

                    cntr = cntr+sig

                    do j=1,n

                        if (sig < 0) then
                            tmp(j) = tmp(j) - mat(pos, j)!sign(mat(pos, j), sgntmp)
                        else
                            tmp(j) = tmp(j) + mat(pos, j)!sign(mat(pos, j), sgntmp)
                        end if

                        rowsumprod = rowsumprod * tmp(j)
                    end do

                end if



                if(mod(n-cntr,2)==0) then
                    permtmp = permtmp + rowsumprod
                else
                    permtmp = permtmp - rowsumprod
                end if

            end do

            tot(ii) = permtmp

        end do
!$OMP END PARALLEL DO

        permanent = sum(tot)
        permanent_out = real(permanent, dp) + (0.0_dp, 1.0_dp)*real(aimag(permanent), dp)

        deallocate(tot,threadbound_low,threadbound_hi,chitmp,tmp)
    end subroutine comp

    subroutine dec2bin (kk, nnn, mat)
        integer(ip2), intent(in) :: kk, nnn
        real(dp), intent(out)   :: mat(1:nnn+1)

        ! local variables
        integer(ip2) :: i, k

        mat(:) = 0.0_dp

        k = kk
        i = nnn

        do while (k > 0 .and. i>0)
            mat(i) = mod(k, 2)
            k = k/2 !floor(real(k, wp)/2.0_wp)
            i = i-1
        end do

        mat(nnn+1) = sum(mat(1:nnn))
    end subroutine dec2bin


    function igray(n,is)
        integer(ip2), intent(in) :: n, is
        integer(ip2) :: igray

        ! local variables
        integer(ip2) :: idiv,ish

        if (is >= 0) then
                igray = ieor(n,n/2)
        else
                ish = -1
                igray = n
                do
                    idiv = ishft(igray,ish)
                    igray = ieor(igray,idiv)
                    if (idiv <= 1 .or. ish == -16) RETURN
                        ish = ish+ish
                end do
        end if
    end function igray

end module perm

! Copyright 2019 Xanadu Quantum Technologies Inc.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

! Module containing some common variables
module vars
    use kinds
    implicit none

    real(wp), parameter    :: pi = 3.141592653589793238462643383279
    complex(wp), parameter :: zzero = (0.0_wp, 0.0_wp), &
                              zone = (1.0_wp, 0.0_wp), &
                              zi = (0.0_wp, 1.0_wp)

    ! torontonian variables
    character                :: mattype*10
    complex(wp), allocatable :: inv_mat_comp(:, :)


    ! permanent variables
    integer(ip)            :: nn, nni, maxthreads
    real(wp), parameter    :: oneoverlog2 = 1.0_wp/log(2.0_wp)

    namelist /input/ nni, nn, maxthreads

end module vars

! Copyright 2019 Xanadu Quantum Technologies Inc.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module torontonian
    use kinds
    use vars
    use omp_lib
    use ISO_FORTRAN_ENV
    use linpack_q_complex

    implicit none

    contains

    subroutine tor(matin, tor_out)
        complex(dp), intent(in)  :: matin(:, :)
        complex(dp), intent(out) :: tor_out

        ! local variables
        complex(wp), allocatable :: mat(:, :)
        complex(dp), allocatable :: mat_dp1(:, :), mat_dp2(:, :), mat_dp3(:, :)

        real(dp)     :: tmp, tmp2, tmp3
        real(wp)     :: tmpqp
        integer(ip2) :: n, i, j, k, total, cntr, ell, ii, nthreads
        complex(wp)  :: tmpsum_complex, invdet_complex

        ! result variables
        complex(wp), allocatable :: submat_comp(:, :)

        ! determinant work variables
        complex(wp)                  :: det_complex(2)
        integer(kind=4)              :: info, lda, nn, job

        integer(kind=4), allocatable :: ip2vt(:)
        real(wp), allocatable        :: work(:)
        complex(wp), allocatable     :: work_complex(:)
        integer(ip2), allocatable    :: bin(:), iter(:), iter2(:)

        n = size(matin(1,:))

        allocate(mat(1:n, 1:n))

        forall (i=1:n, j=1:n) mat(i,j) = zone*real(matin(i,j), wp) + zi*real(aimag(matin(i,j)), wp)!matdp(i,j)!(real(matdp(i,j), wp), aimag(matdp(i,j), wp))


        ell = n/2

        allocate(bin(1:ell)) !, set(1:j))

        tmpsum_complex = zzero

        !$OMP PARALLEL DO shared(mat, ell, mattype) private(ii, bin, total, submat_comp, &
        !$OMP                    cntr, k, iter, iter2, ip2vt, nn, work_complex, det_complex, job, &
        !$OMP                     invdet_complex, lda) reduction(+:tmpsum_complex)

        do ii=0, 2**ell-1
            call dec2bin(ii, ell, bin, total)

            allocate(iter(1:total), iter2(1:2*total), submat_comp(1:2*total, 1:2*total))

            cntr = 1
            do k=1,ell
                if (bin(k) == 1) then
                    iter(cntr) = k
                    cntr = cntr + 1
                end if
            end do

            iter2(1:total) = iter(1:total)
            iter2(total+1:2*total) = iter(1:total) + ell

            forall (i=1:2*total,j=1:2*total) submat_comp(i, j) = -mat(iter2(i), iter2(j))
            forall (i=1:2*total) submat_comp(i, i) = zone + submat_comp(i, i)

            lda = 2*total
            nn = 2*total

            allocate(ip2vt(1:nn), work_complex(1:nn))

            if (nn > 0) then
                call qgefa_complex(submat_comp, lda, nn, ip2vt, info)
            end if
            job = 10
            call qgedi_complex(submat_comp, lda, nn, ip2vt, det_complex, work_complex, job )

            invdet_complex = zone/det_complex(1) * 10.0_wp**(-real(det_complex(2)))
            tmpsum_complex = tmpsum_complex + (-1.0_wp)**(ell-total)*sqrt(invdet_complex)
            !print*, tmpsum_complex
            deallocate(iter, iter2, submat_comp, ip2vt, work_complex)
        end do
        !$OMP END PARALLEL DO

        !tor = (1.0_wp, 0.0_wp)!tmpsum_complex
        tor_out = tmpsum_complex

    end subroutine tor

    subroutine det_real(matin, det_out)
        real(dp), intent(in)  :: matin(:, :)
        real(dp), intent(out) :: det_out

        ! determinant work variables
        real(wp)        :: det(2), tmpdet
        integer(kind=4) :: info, lda, nn, job, i, j
        integer(ip2)    :: n

        integer(kind=4), allocatable :: ip2vt(:)
        real(wp), allocatable        :: work(:), mat(:, :)

        nn = size(matin(1,:))
        lda = nn

        allocate(ip2vt(1:nn), work(1:nn), mat(1:nn,1:nn))

        forall (i=1:nn,j=1:nn) mat(i,j) = real(matin(i,j), wp)

        call qgefa(mat, lda, nn, ip2vt, info)

        job = 10

        call qgedi(mat, lda, nn, ip2vt, det, work, job )

        tmpdet = det(1) * 10.0_wp**(real(det(2), wp))

        det_out = real(tmpdet, dp)

        deallocate(ip2vt, work, mat)
    end subroutine det_real

    subroutine det_complex(matin, det_out)
        complex(dp), intent(in)  :: matin(:, :)
        complex(dp), intent(out) :: det_out

        ! determinant work variables
        complex(wp)     :: det(2), tmpdet
        integer(kind=4) :: info, lda, nn, job, i, j
        integer(ip2)    :: n

        integer(kind=4), allocatable :: ip2vt(:)
        complex(wp), allocatable     :: work(:), mat(:, :)

        nn = size(matin(1,:))
        lda = nn

        allocate(ip2vt(1:nn), work(1:nn), mat(1:nn,1:nn))

        forall (i=1:nn, j=1:nn) mat(i,j) = zone*real(matin(i,j), wp) + zi*real(aimag(matin(i,j)), wp)

        call qgefa_complex(mat, lda, nn, ip2vt, info)

        job = 10

        call qgedi_complex(mat, lda, nn, ip2vt, det, work, job)

        tmpdet = det(1) * 10.0_wp**(real(det(2), wp))

        det_out = zone*real(tmpdet, wp) + zi*real(aimag(tmpdet), wp)

        deallocate(ip2vt, work, mat)
    end subroutine det_complex

    subroutine dec2bin (kk, nnn, matt, summ)
        integer(ip2), intent(in)  :: kk, nnn
        integer(ip2), intent(out) :: matt(1:nnn)
        integer(ip2), intent(out) :: summ

        ! local variables
        integer(ip2) :: i, k

        matt(:) = 0

        k = kk
        i = nnn

        do while (k > 0 .and. i>0)
            matt(i) = mod(k, 2)
            k = k/2 !floor(real(k, wp)/2.0_wp)
            i = i-1
        end do

        summ = sum(matt(1:nnn))
    end subroutine dec2bin

end module torontonian

! Copyright 2019 Xanadu Quantum Technologies Inc.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

! Module containing custom precision types
module kinds
    implicit none

    integer, parameter :: sp = selected_real_kind(5,30)
    integer, parameter :: dp = selected_real_kind(9,99)
    integer, parameter :: qp = selected_real_kind(20, 199)
    integer, parameter :: wp = dp
    integer, parameter :: ip = selected_int_kind(8)
    integer, parameter :: ip2 = selected_int_kind(16)

    ! These empty arrays are used to initialize variables to either the min or
    ! max possible number of kind wp or integer.
    real(wp), dimension(2:1)    :: empty
    integer(ip), dimension(2:1) :: iempty
end module kinds
